<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb620cb4ae090d06_04398805/operators/FlowchartOperator_lb620cb4ae090d06_04398805.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb620cb4ae090d06_04398805/helpers/DateTimeConverter_lb620cb4ae090d06_04398805.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb620cb4ae090d06_04398805/helpers/DecimalConverter_lb620cb4ae090d06_04398805.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb620cb4ae090d06_04398805/helpers/date/DateTimeFactory_lb620cb4ae090d06_04398805.php';

class GetEntityAttributesOperator_lb620cb4ae090d06_04398805_op2 extends FlowchartOperator_lb620cb4ae090d06_04398805{

    protected $entityName;
    protected $emptyEntity;

    protected $entity;
    protected $attributes = array();

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){
        $this->setEntityName($params['inDataPorts']['entity']['value']);

        $this->inDataPorts = array();
        foreach($params['inDataPorts'] as $key => $value)
            if($key == 'entity')
                $this->inDataPorts[$key]['id'] = $value['id'];
            else
                $this->inDataPorts[$key] = $value;
    }

    protected function setEntityName($moduleName){
        $this->entityName = $moduleName; //$beanList[$moduleName];
    }

    public function setInDataPortById($id, $value){
        if($id == 'entity'){
            $this->entity = $value;
        }else
            parent::setInDataPortById($id, $value);
    }

    public function process($params = array()){
        $this->initOutDataPortsWithAttr();
    }

    protected function initOutDataPortsWithAttr(){
        $this->checkCurrentAttrValue('primary_address_country');
        if(isset($this->entity->primary_address_country)){
            $this->attributes['primary_address_country'] = $this->convertAttrValue('primary_address_country', $this->entity->primary_address_country);
        }else{
            $this->attributes['primary_address_country'] = NULL;
        }
        $this->checkCurrentAttrValue('primary_address_postalcode');
        if(isset($this->entity->primary_address_postalcode)){
            $this->attributes['primary_address_postalcode'] = $this->convertAttrValue('primary_address_postalcode', $this->entity->primary_address_postalcode);
        }else{
            $this->attributes['primary_address_postalcode'] = NULL;
        }
        $this->checkCurrentAttrValue('primary_address_state');
        if(isset($this->entity->primary_address_state)){
            $this->attributes['primary_address_state'] = $this->convertAttrValue('primary_address_state', $this->entity->primary_address_state);
        }else{
            $this->attributes['primary_address_state'] = NULL;
        }
        $this->checkCurrentAttrValue('primary_address_city');
        if(isset($this->entity->primary_address_city)){
            $this->attributes['primary_address_city'] = $this->convertAttrValue('primary_address_city', $this->entity->primary_address_city);
        }else{
            $this->attributes['primary_address_city'] = NULL;
        }
        $this->checkCurrentAttrValue('primary_address_street');
        if(isset($this->entity->primary_address_street)){
            $this->attributes['primary_address_street'] = $this->convertAttrValue('primary_address_street', $this->entity->primary_address_street);
        }else{
            $this->attributes['primary_address_street'] = NULL;
        }
        $this->checkCurrentAttrValue('id');
        if(isset($this->entity->id)){
            $this->attributes['id'] = $this->convertAttrValue('id', $this->entity->id);
        }else{
            $this->attributes['id'] = NULL;
        }
    }

    public function getOutDataByPortId($portId){
        $field = $this->outDataPorts[$portId]['value'];
        return $this->attributes[$field];
    }

    protected function convertAttrValue($fieldName, $fieldValue){

        if($this->entity instanceof SugarBean){
            if(!empty($this->entity->field_defs[$fieldName])){
                $fieldDef = $this->entity->field_defs[$fieldName];
            }
        }else{
            if(empty($this->emptyEntity)){
                $this->emptyEntity = BeanFactory::getBean($this->entityName);
            }

            if(!empty($this->emptyEntity->field_defs[$fieldName])){
                $fieldDef = $this->emptyEntity->field_defs[$fieldName];
            }
        }

        if(empty($fieldDef))
            return $fieldValue;

        switch($fieldDef['type']){
            case 'date':
                $dateTimeFactory = new DateTimeFactory_lb620cb4ae090d06_04398805();
                $fieldValue = $dateTimeFactory->getDateTimeFromDbDateString($fieldValue);
                break;
            case 'datetime':
            case 'datetimecombo':
                $dateTimeFactory = new DateTimeFactory_lb620cb4ae090d06_04398805();
                $fieldValue = $dateTimeFactory->getDateTimeFromDbDateTimeString($fieldValue);
                break;
            case 'currency':
            case 'decimal':
            case 'double':
            case 'float':
                require_once 'custom/PxRoutines/LogicBuilderPackages/lb620cb4ae090d06_04398805/helpers/DecimalConverter_lb620cb4ae090d06_04398805.php';
                $fieldValue = DecimalConverter_lb620cb4ae090d06_04398805::convertToDisplay($fieldDef, $fieldValue);
                break;
            case 'integer':
            case 'int':
                break;
            default:
                if(empty($fieldValue)){
                    $fieldValue = NULL;
                }
                break;
        }

        return $fieldValue;
    }

    protected function checkCurrentAttrValue($fieldName){
        if($fieldName == 'date_entered' && $this->entity instanceof SugarBean &&
            empty($this->entity->date_entered) && !empty($this->entity->fetched_row['date_entered'])){
            $this->entity->date_entered = $this->entity->fetched_row['date_entered'];
        }
    }

}
