<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb620cb4ae090d06_04398805/operators/FlowchartOperator_lb620cb4ae090d06_04398805.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb620cb4ae090d06_04398805/helpers/date/DateTimeFactory_lb620cb4ae090d06_04398805.php';

class SetEntityAttributesOperator_lb620cb4ae090d06_04398805_op11 extends FlowchartOperator_lb620cb4ae090d06_04398805{

    protected $entity;
    protected $attributes;

    public function __construct($params){
        parent::__construct($params);
    }

    public function process($params = array()){
        $this->initBeanWithInData();
    }

    protected function initBeanWithInData(){
        $fieldDef = $this->entity->field_defs['address_country_c'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->address_country_c = $this->getDateInDbFormat(
                    $this->attributes['address_country_c']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->address_country_c = $this->getDateTimeInDbFormat(
                    $this->attributes['address_country_c']
                );
                break;
            default:
                $this->entity->address_country_c = $this->attributes['address_country_c'];
            }
        $fieldDef = $this->entity->field_defs['address_postalcode_c'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->address_postalcode_c = $this->getDateInDbFormat(
                    $this->attributes['address_postalcode_c']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->address_postalcode_c = $this->getDateTimeInDbFormat(
                    $this->attributes['address_postalcode_c']
                );
                break;
            default:
                $this->entity->address_postalcode_c = $this->attributes['address_postalcode_c'];
            }
        $fieldDef = $this->entity->field_defs['address_state_c'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->address_state_c = $this->getDateInDbFormat(
                    $this->attributes['address_state_c']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->address_state_c = $this->getDateTimeInDbFormat(
                    $this->attributes['address_state_c']
                );
                break;
            default:
                $this->entity->address_state_c = $this->attributes['address_state_c'];
            }
        $fieldDef = $this->entity->field_defs['address_city_c'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->address_city_c = $this->getDateInDbFormat(
                    $this->attributes['address_city_c']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->address_city_c = $this->getDateTimeInDbFormat(
                    $this->attributes['address_city_c']
                );
                break;
            default:
                $this->entity->address_city_c = $this->attributes['address_city_c'];
            }
        $fieldDef = $this->entity->field_defs['address_street_c'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->address_street_c = $this->getDateInDbFormat(
                    $this->attributes['address_street_c']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->address_street_c = $this->getDateTimeInDbFormat(
                    $this->attributes['address_street_c']
                );
                break;
            default:
                $this->entity->address_street_c = $this->attributes['address_street_c'];
            }
    }

    private function getDateInDbFormat($value)
    {
        $date = $this->getDateTimeFromValue($value);
        if (empty($date)) {
            return null;
        }
        return $date->asDbDate(false);
    }

    private function getDateTimeInDbFormat($value)
    {
        $dateTime = $this->getDateTimeFromValue($value);
        if (empty($dateTime)) {
            return null;
        }
        return $dateTime->asDb(true);
    }

    private function getDateTimeFromValue($date)
    {
        if ($date instanceof SugarDateTime) {
            return $date;
        }
        if (!is_string($date)) {
            return null;
        }
        $dateTimeFactory = new DateTimeFactory_lb620cb4ae090d06_04398805();
        return $dateTimeFactory->getDateTimeFromUnknownFormat($date);
    }

    public function setInDataPortById($id, $value){
        if(!empty($this->inDataPorts[$id])){
            if($value instanceof SugarBean){
                $this->entity = $value;
            }else{
                $this->attributes[$this->inDataPorts[$id]['value']] = $value;
            }
        }
    }

    public function getOutDataByPortId($portId){
        return $this->entity;
    }

}
